//
//  SAAppDelegate.m
//  saccounts_ios_sdk_sso_demo
//
//  Created by BabyDuncan on 13-9-2.
//  Copyright (c) 2013年 SOHU.COM. All rights reserved.
//

#import <saccounts_ios_sdk_sso_framework/Weibo.h>
#import <saccounts_ios_sdk_sso_framework/SohuPlusToken.h>
#import <saccounts_ios_sdk_sso_framework/SohuPlus.h>
#import <saccounts_ios_sdk_sso_framework/TencentOAuth.h>
#import <saccounts_ios_sdk_sso_framework/Tencent.h>
#import <saccounts_ios_sdk_sso_framework/DOUAPIConfig.h>
#import <saccounts_ios_sdk_sso_framework/Netease.h>

#import "SAAppDelegate.h"

@implementation SAAppDelegate

@synthesize weiboApi;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    //注册新浪微博的app
    [[Weibo new] registApp:kAppKey];
    //注册腾讯qq的app
//    tencentOAuth = [[TencentOAuth alloc] initWithAppId:qqAppKey
//                                           andDelegate:self];
//    tencentOAuth.redirectURI = qqRedirectURI;
    [[Tencent new] registApp:qqAppKey delegate:self redirectURI:qqRedirectURI];
    //注册豆瓣的信息
    DOUService *service = [DOUService sharedInstance];
    service.clientId = doubankAPIKey;
    service.clientSecret = doubankPrivateKey;
    if ([service isValid]) {
        service.apiBaseUrlString = kHttpsApiBaseUrl;
    }
    //注册网易的信息
//    weiboApi = [[WeiboCommonAPI alloc] init];
//    [[NSNotificationCenter defaultCenter] addObserver:self
//                                             selector:@selector(publishMessageResult:)
//                                                 name:PublishMessageResultNotification
//                                               object:nil];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application {
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application {
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//                        对URL的处理区域
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////

- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation {
    // 通过url 获得scheme 根据scheme 的格式来确定是调用微博的sdk还是腾讯qq的sdk还是其他的sdk
    NSString *scheme = [url scheme];
    // 如果是新浪微博的请求
    if ([scheme hasPrefix:[NSString stringWithFormat:@"wb"]]) {
        return [WeiboSDK handleOpenURL:url delegate:self];
        // 如果是腾讯空间的请求
    } else if ([scheme hasPrefix:[NSString stringWithFormat:@"tencent"]]) {
        return [TencentOAuth HandleOpenURL:url];
    } else {
        return YES;
    }
}

- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url {
    return [TencentOAuth HandleOpenURL:url];
}


//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//                        新浪微博的协议实现区域
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////


- (void)didReceiveWeiboResponse:(WBBaseResponse *)response {
    if ([response isKindOfClass:WBSendMessageToWeiboResponse.class]) {
        NSString *title = @"发送结果";
        NSString *message = [NSString stringWithFormat:@"响应状态: %d\n响应UserInfo数据: %@\n原请求UserInfo数据: %@",
                                                       response.statusCode, response.userInfo, response.requestUserInfo];
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:title
                                                        message:message
                                                       delegate:nil
                                              cancelButtonTitle:@"确定"
                                              otherButtonTitles:nil];
        [alert show];
    }
    else if ([response isKindOfClass:WBAuthorizeResponse.class]) {
//        NSString *uId = [(WBAuthorizeResponse *) response userID];
//        NSString *at = [(WBAuthorizeResponse *) response accessToken];
//        NSDate *exp = [(WBAuthorizeResponse *) response expirationDate];
//        NSString *timeSp = [NSString stringWithFormat:@"%d", (long) [exp timeIntervalSince1970]];

//        NSLog(@"uid is %@,and accesstoken is %@,and expire is %@", uId, at, timeSp);

        __block NSString *result;
        void (^mySuccessHandler)(SohuPlusToken *) = ^(SohuPlusToken *token) {
            NSLog(@"%@ | %@ | %@", token.accessToken, token.refreshToken, token.expire);
            result = token.accessToken;
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"response from sohuplus"
                                                            message:result
                                                           delegate:nil
                                                  cancelButtonTitle:@"确定"
                                                  otherButtonTitles:nil];
            [alert show];
        };

        void (^myErrorHandler)() = ^(void) {
            NSLog(@"Failure");
        };

        SohuPlus *sp = [SohuPlus new];
        NSString *_token = [sp genTokenFromWeibo:response];
        NSLog(@"real token is %@", _token);
        NSString *token = [sp genToken:@"3489940871" accessToken:@"2.00tC8LoDnh6MOE18b022a8458wRY9E" expire:@"1"];
        NSLog(@"fake token is %@", token);
        [sp exchangeToken:token provider:@"weibo" appid:@"30000001" clientid:@"30000001" success:mySuccessHandler error:myErrorHandler];
    }
}


//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//                        腾讯qq的协议实现区域
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////


- (void)tencentDidNotLogin:(BOOL)cancelled {
    [[NSNotificationCenter defaultCenter] postNotificationName:@"login failed" object:self];
}

- (void)tencentDidLogin {


    NSLog(@"%@ | %@ | %@", [[Tencent tencentOAuth] accessToken], [[Tencent tencentOAuth] openId], [[Tencent tencentOAuth] expirationDate]);

//    NSString * result = @"token is" + [tencentOAuth accessToken] + @" and openId is " + [tencentOAuth openId];

    NSString *result_ = [@"" stringByAppendingFormat:@"token is %@ and openId is %@", [[Tencent tencentOAuth] accessToken], [[Tencent tencentOAuth] openId]];

    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"response from qq OK!!"
                                                    message:result_
                                                   delegate:nil
                                          cancelButtonTitle:@"确定"
                                          otherButtonTitles:nil];
    [alert show];

}

- (void)tencentDidNotNetWork {
    [[NSNotificationCenter defaultCenter] postNotificationName:@"network error .." object:self];
}

- (BOOL)onTencentReq:(TencentApiReq *)req {
    return YES;
}


///////////////////网易
-(void)publishMessageResult:(NSNotification*)notification
{
    NSDictionary* dict = [notification userInfo];
    if (dict) {
        BOOL success=[[dict objectForKey:@"success"] boolValue];
        if (!success) {
            return;
        }
        NSInteger weiboid=[[dict objectForKey:@"weiboid"] intValue];
        //NSInteger userData = [[dict objectForKey:@"userData"] intValue];
        NSString* result = nil;
        switch (weiboid) {
            case Weibo_Sina:
                result=@"已分享到新浪微博";
                break;
            case Weibo_Tencent:
                result=@"已分享到腾讯微博";
                break;
            case Weibo_Netease:
                result=@"已分享到网易微博";
                break;
            case Weibo_Sohu:
                result=@"已分享到搜狐微博";
                break;
            case Weibo_Max:
                return;
                break;
            default:

                break;
        }
        NSLog(@"%@", result);
    }
}

@end
