//
//  SADBViewController.m
//  saccounts_ios_sdk_sso_demo
//
//  Created by BabyDuncan on 13-10-8.
//  Copyright (c) 2013年 SOHU.COM. All rights reserved.
//

#import <saccounts_ios_sdk_sso_framework/DOUAPIConfig.h>
#import <saccounts_ios_sdk_sso_framework/DOUOAuthStore.h>

#import "SADBViewController.h"

@interface NSString (ParseCategory)
- (NSMutableDictionary *)explodeToDictionaryInnerGlue:(NSString *)innerGlue
                                           outterGlue:(NSString *)outterGlue;
@end

@implementation NSString (ParseCategory)

- (NSMutableDictionary *)explodeToDictionaryInnerGlue:(NSString *)innerGlue
                                           outterGlue:(NSString *)outterGlue {
    // Explode based on outter glue
    NSArray *firstExplode = [self componentsSeparatedByString:outterGlue];
    NSArray *secondExplode;

    // Explode based on inner glue
    NSInteger count = [firstExplode count];
    NSMutableDictionary *returnDictionary = [NSMutableDictionary dictionaryWithCapacity:count];
    for (NSInteger i = 0; i < count; i++) {
        secondExplode =
                [(NSString *) [firstExplode objectAtIndex:i] componentsSeparatedByString:innerGlue];
        if ([secondExplode count] == 2) {
            [returnDictionary setObject:[secondExplode objectAtIndex:1]
                                 forKey:[secondExplode objectAtIndex:0]];
        }
    }
    return returnDictionary;
}

@end

@interface SADBViewController ()

@property(nonatomic, retain) UIWebView *webView;
@property(nonatomic, retain) NSURL *requestURL;

@end

@implementation SADBViewController

@synthesize webView = webView_;
@synthesize requestURL = requestURL_;

- (id)initWithRequestURL:(NSURL *)aURL; {
    self = [super init];
    if (self) {
        self.requestURL = aURL;
    }
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    self.navigationItem.title = @"登录";
    webView_ = [[UIWebView alloc] initWithFrame:CGRectMake(0,
            0,
            self.view.bounds.size.width,
            self.view.bounds.size.height - 49)];
    webView_.scalesPageToFit = YES;
    webView_.delegate = self;
    NSString *str = [NSString stringWithFormat:@"https://www.douban.com/service/auth2/auth?client_id=%@&redirect_uri=%@&response_type=code", doubankAPIKey, doubankRedirectUrl ];
    NSString *urlStr = [str stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
    NSURL *url = [NSURL URLWithString:urlStr];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    [webView_ loadRequest:request];
    [self.view addSubview:webView_];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - UIWebViewDelegate

- (BOOL)           webView:(UIWebView *)webView
shouldStartLoadWithRequest:(NSURLRequest *)request
            navigationType:(UIWebViewNavigationType)navigationType {

    NSURL *urlObj = [request URL];
    NSString *url = [urlObj absoluteString];


    if ([url hasPrefix:doubankRedirectUrl]) {

        NSString *query = [urlObj query];
        NSMutableDictionary *parsedQuery = [query explodeToDictionaryInnerGlue:@"="
                                                                    outterGlue:@"&"];

        //access_denied
        NSString *error = [parsedQuery objectForKey:@"error"];
        if (error) {
            return NO;
        }

        //access_accept
        NSString *code = [parsedQuery objectForKey:@"code"];
        DOUOAuthService *service = [DOUOAuthService sharedInstance];
        service.authorizationURL = kTokenUrl;
        service.delegate = self;
        service.clientId = doubankAPIKey;
        service.clientSecret = doubankPrivateKey;
        service.callbackURL = doubankRedirectUrl;
        service.authorizationCode = code;

        [service validateAuthorizationCode];

        return NO;
    }

    return YES;
}


- (void)OAuthClient:(DOUOAuthService *)client didAcquireSuccessDictionary:(NSDictionary *)dic {
    NSLog(@"success!");
    [self.navigationController popViewControllerAnimated:YES];
    [self dismissModalViewControllerAnimated:YES];
    DOUOAuthStore *store = [DOUOAuthStore sharedInstance];
    NSString *accesstoken = store.accessToken;
    int userid = store.userId;
    NSDate *expire = store.expiresIn;
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"response from douban OK!!"
                                                    message:accesstoken
                                                   delegate:nil
                                          cancelButtonTitle:@"确定"
                                          otherButtonTitles:nil];
    [alert show];

}

- (void)OAuthClient:(DOUOAuthService *)client didFailWithError:(NSError *)error {
    NSLog(@"Fail!");
}


@end
