//
// Created by BabyDuncan on 13-9-27.
// Copyright (c) 2013 SOHU.COM. All rights reserved.
//
// To change the template use AppCode | Preferences | File Templates.
//


#import "ActionCollect.h"
#import "HttpClient.h"

#define dataCollectUrl @"http://10.10.69.108:9999/producer/"

@implementation ActionCollect


//用户打开了app
//用户打开app 把
- (void)appStart; {
    NSString *payload = [self generateAppStartAndClosePayLoad:@"appStart"];
    if (![payload isEqual:nil]) {
        NSMutableDictionary *params = [[NSMutableDictionary alloc] init];
        [params setObject:@"appCollect" forKey:@"topic"];
        [params setObject:[self generateAppStartAndClosePayLoad:@"appStart"] forKey:@"content"];
        HttpClient *httpClient = [HttpClient new];
        [httpClient post:dataCollectUrl postInfo:params success:nil fail:nil];
    }

}

//用户关闭了app
- (void)appClose; {
    NSString *payload = [self generateAppStartAndClosePayLoad:@"appClose"];
    if (![payload isEqual:nil]) {
        NSMutableDictionary *params = [[NSMutableDictionary alloc] init];
        [params setObject:@"appCollect" forKey:@"topic"];
        [params setObject:[self generateAppStartAndClosePayLoad:@"appStart"] forKey:@"content"];
        HttpClient *httpClient = [HttpClient new];
        [httpClient post:dataCollectUrl postInfo:params success:nil fail:nil];
    }
}

// 用户使用某一款第三方提供商进行sso登陆
- (void)ssoLogin:(NSString *)ssoProvider; {
    NSString *payload = [self generateSsoLoginAndLogoutPayLoad:@"ssoLogin" ssoProvider:ssoProvider];
    if (![payload isEqual:nil]) {
        NSMutableDictionary *params = [[NSMutableDictionary alloc] init];
        [params setObject:@"appCollect" forKey:@"topic"];
        [params setObject:[self generateAppStartAndClosePayLoad:@"appStart"] forKey:@"content"];
        HttpClient *httpClient = [HttpClient new];
        [httpClient post:dataCollectUrl postInfo:params success:nil fail:nil];
    }
}

//用户退出sso登陆
- (void)ssoLogout:(NSString *)ssoProvider; {
    NSString *payload = [self generateSsoLoginAndLogoutPayLoad:@"ssoLogout" ssoProvider:ssoProvider];
    if (![payload isEqual:nil]) {
        NSMutableDictionary *params = [[NSMutableDictionary alloc] init];
        [params setObject:@"appCollect" forKey:@"topic"];
        [params setObject:[self generateAppStartAndClosePayLoad:@"appStart"] forKey:@"content"];
        HttpClient *httpClient = [HttpClient new];
        [httpClient post:dataCollectUrl postInfo:params success:nil fail:nil];
    }
}

// 获取用户手机的host
- (NSString *)getHostName; {
    return [[NSProcessInfo processInfo] hostName];
}

//获取用户手机的操作系统
- (NSString *)getOS; {
    return [[NSProcessInfo processInfo] operatingSystemName];
}

//获取用户手机操作系统的版本
- (NSString *)getOSVersion; {
    return [[NSProcessInfo processInfo] operatingSystemVersionString];
}

//获取当前应用程序的名称
- (NSString *)getCurrentApp; {
    return [[NSProcessInfo processInfo] processName];
}

//获取app的udid
- (NSString *)getUDID; {
    return [[UIDevice currentDevice].identifierForVendor UUIDString];
}

// 生成app启动或者app退出时候的payload
- (NSString *)generateAppStartAndClosePayLoad:(NSString *)action; {
    NSDictionary *d = [NSDictionary dictionaryWithObjectsAndKeys:[self getHostName], @"hostname", action, @"action",
                                                                 [self getOS], @"osname", [self getOSVersion], @"osversion",
                                                                 [self getCurrentApp], @"app", [self getCurrentTime], @"date",
                                                                 [self getUDID], @"udid", nil];
    NSError *error;
    NSData *registerData = [NSJSONSerialization dataWithJSONObject:d options:NSJSONWritingPrettyPrinted error:&error];
    NSString *result = [[NSString alloc] initWithData:registerData encoding:NSUTF8StringEncoding];
    if (!error) {
        result = [result stringByReplacingOccurrencesOfString:@"\t" withString:@""];
        result = [result stringByReplacingOccurrencesOfString:@"\n" withString:@""];
        result = [result stringByReplacingOccurrencesOfString:@" " withString:@""];
        return result;
    } else {
        return nil;
    }

}

// 生成sso登陆以及登出的payload
- (NSString *)generateSsoLoginAndLogoutPayLoad:(NSString *)action
                                   ssoProvider :(NSString *)ssoProvider; {
    NSDictionary *d = [NSDictionary dictionaryWithObjectsAndKeys:[self getHostName], @"hostname", action, @"action",
                                                                 ssoProvider, @"sso", [self getCurrentTime], @"date",
                                                                 [self getOS], @"osname", [self getOSVersion], @"osversion",
                                                                 [self getCurrentApp], @"app",
                                                                 [self getUDID], @"udid", nil];
    NSError *error;
    NSData *registerData = [NSJSONSerialization dataWithJSONObject:d options:NSJSONWritingPrettyPrinted error:&error];
    NSString *result = [[NSString alloc] initWithData:registerData encoding:NSUTF8StringEncoding];
    if (!error) {
        result = [result stringByReplacingOccurrencesOfString:@"\t" withString:@""];
        result = [result stringByReplacingOccurrencesOfString:@"\n" withString:@""];
        result = [result stringByReplacingOccurrencesOfString:@" " withString:@""];
        return result;
    } else {
        return nil;
    }

}

// 获取当前时间
- (NSString *)getCurrentTime; {
    NSDate *newDate = [NSDate date];
    NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
    [dateFormat setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
    NSString *newDate_ = [dateFormat stringFromDate:newDate];
    [dateFormat setFormatterBehavior:NSDateFormatterFullStyle];
    [dateFormat setTimeZone:[NSTimeZone timeZoneWithAbbreviation:@"UTC"]];
    return newDate_;
}

@end