//
// Created by BabyDuncan on 13-9-10.
// Copyright (c) 2013 SOHU.COM. All rights reserved.
//
// To change the template use AppCode | Preferences | File Templates.
//


#import <Foundation/Foundation.h>
#import "Tencent.h"
#import "SohuPlusProfile.h"

@class SohuPlusToken;
@class WBBaseResponse;
@class TencentOAuth;
@class SohuPlusProfile;

@interface SohuPlus : NSObject

//- (void)__exchangeToken:(NSString *)token
//               provider:(NSString *)provider
//                  appid:(NSString *)appId
//               clientId:(NSString *)clientId
//                success:(void (^)(AFHTTPRequestOperation *, id))successHandler
//                   fail:(void (^)(AFHTTPRequestOperation *, NSError *))errorHandler;

- (void)exchangeToken:(NSString *)token
             provider:(NSString *)provider
                appid:(NSString *)appId
             clientid:(NSString *)clientId
              success:(void (^)(SohuPlusToken *))yourSuccessHandler
                error:(void (^)(void))yourErrorHandler;

// 带上错误信息回调的handler
- (void)exchangeToken:(NSString *)token
             provider:(NSString *)provider
                appid:(NSString *)appId
             clientid:(NSString *)clientId
              success:(void (^)(SohuPlusToken *))yourSuccessHandler
          errorString:(void (^)(NSString *))yourErrorHandler;

- (NSString *)genToken:(NSString *)userId
           accessToken:(NSString *)accessToken
                expire:(NSString *)expireTime;

// 从微博的响应中生成 换取sohuplus的令牌
- (NSString *)genTokenFromWeibo:(WBBaseResponse *)response;

// 从腾讯空间的响应中 生成换取sohuplus的令牌
- (NSString *)genTokenFromTencent:(TencentOAuth *)tencentOAuth;


// 从sohuplus获得个人基本资料
//成功情况URL
//http://open.account.sohu.com/oauth2/resource/?client_id=10000004&client_secret=cd35c38500e64ca3bb57c53a2394b75c&scope=all&instance_id=test&resource_type=full.get&access_token=eda33ff85703469a3247c70ed5f810f45d954ba1d27dee73001a6a3e200f98a5
//成功的情况:{"resource": {"msg": "get success", "code": 0,
// "data": {"status": "2", "sname": "s1258235080", "tiny_avatar": "http://s5.suc.itc.cn/ux_sogou_member/src/asset/sogou/img_sogouAvatar55.png", "mid_avatar": "http://s5.suc.itc.cn/ux_sogou_member/src/asset/sogou/img_sogouAvatar95.png", "sid": "1258235080", "update_at": "1362844800000", "create_at": "0", "nick": "\u6b66\u5065\u8c22\u8c22", "active_at": "1361176574000", "email": "", "large_avatar": "http://s5.suc.itc.cn/ux_sogou_member/src/asset/sogou/img_sogouAvatar175.png"}},
// "result": "confirm"}

//失败情况URL
//http://open.account.sohu.com/oauth2/resource/?client_id=10000004&client_secret=cd35c38500e64ca3bb57c53a2394b75c&scope=all&instance_id=test&resource_type=full.get&username=1258235080&access_token=6f0edd798c38837fb6dba48f7127971a1ff266db5649c2cc7e21c5f30b846974
//失败的情况:
//{"error_uri": "www.sohu.com", "error_description_cn": "", "error_description": "Token decode failed. (access_token=be113f09a677dc28e8158cfed1963656, client_id=1)",
// "result": "refuse", "error": "invalid_token"}

- (void)getProfile:(NSString *)clientId
      clientSecret:(NSString *)clientSecret
             scope:(NSString *)scope
        instanceId:(NSString *)instanceId
          username:(NSString *)username
       accessToken:(NSString *)accessToken
           success:(void (^)(SohuPlusProfile *))yourSuccessHandler
             error:(void (^)(NSString *))yourErrorHandler;


@end