//
// Created by BabyDuncan on 13-9-10.
// Copyright (c) 2013 SOHU.COM. All rights reserved.
//
// To change the template use AppCode | Preferences | File Templates.
//


#import "SohuPlus.h"
#import "RSA.h"
#import "HttpClient.h"
#import "SohuPlusToken.h"
#import "WeiboSDK.h"
#import "Tencent.h"
#import "TencentOAuth.h"


@implementation SohuPlus

// input : token->RSA(json( userId accessToken expire))
//         provider->[weibo , qq]
//         appid->10000004
//         secret->a5a1583fd4274eff4d8ec99c634981f4
// return : code->0  data->json(accessToken refreshToken expire )

//demo data
//{
//"access_token" = "2.00pDVhGCsYgrlC1b3c5719010dQAFc";
//"expires_in" = 130069;
//"uid" = 1931291185;
//}

//return

//{"data":
// {"expire":1386656972,
// "accesstoken":"5c975feac5140e2d75cd86c69834211586459f4ec2b4324942299a47e278824f",
// "refreshtoken":"d620190b76839072f277e377ecd56c0d23f2acc36f400d81bf6b756450e836a3"
// },
// "code":0,"msg":"request success
// "}

- (void)__exchangeToken:(NSString *)token
               provider:(NSString *)provider
                  appid:(NSString *)appId
               clientid:(NSString *)clientId
                success:(void (^)(AFHTTPRequestOperation *, id))mySuccessHandler
                   fail:(void (^)(AFHTTPRequestOperation *, NSError *))myErrorHandler; {

    NSString *sohuPlusServerUrl = @"http://plus.sohu.com/spassport/api/mobiletoken";
    NSMutableDictionary *params = [[NSMutableDictionary alloc] init];

    [params setObject:token forKey:@"token"];
    [params setObject:provider forKey:@"provider"];
    [params setObject:appId forKey:@"appid"];
    [params setObject:clientId forKey:@"clientid"];

    HttpClient *httpClient = [HttpClient new];
    [httpClient post:sohuPlusServerUrl postInfo:params success:mySuccessHandler fail:myErrorHandler];

}

- (void)exchangeToken:(NSString *)token
             provider:(NSString *)provider
                appid:(NSString *)appId
             clientid:(NSString *)clientId
              success:(void (^)(SohuPlusToken *))yourSuccessHandler
                error:(void (^)(void))yourErrorHandler; {

    void (^mySuccessHandler)(AFHTTPRequestOperation *, id) = ^(AFHTTPRequestOperation *operation, id result) {
        SohuPlusToken *sohuPlusToken = [SohuPlusToken new];
        NSLog(@"Success: %@", operation.responseString);
        NSString *response = operation.responseString;
        NSError *error;
        NSDictionary *resultJSON = [NSJSONSerialization JSONObjectWithData:[response dataUsingEncoding:NSUTF8StringEncoding] options:kNilOptions error:&error];
        NSDictionary *data = [resultJSON objectForKey:@"data"];
        NSString *code = [resultJSON objectForKey:@"code"];
        NSString *msg = [resultJSON objectForKey:@"msg"];
        if ([code intValue] == 0) {
            [sohuPlusToken setAccessToken:[data objectForKey:@"accesstoken"]];
            [sohuPlusToken setRefreshToken:[data objectForKey:@"refreshtoken"]];
            [sohuPlusToken setExpire:[data objectForKey:@"expire"]];
            yourSuccessHandler(sohuPlusToken);
        }
    };
    void (^myErrorHandler)(AFHTTPRequestOperation *, NSError *) = ^(AFHTTPRequestOperation *operation, NSError *error) {
        NSLog(@"Failure: %@", error);
        yourErrorHandler();
    };

//    NSString *sohuPlusServerUrl = @"http://10.10.68.118:9095/spassport/api/mobiletoken";
    NSString *sohuPlusServerUrl = @"http://plus.sohu.com/spassport/api/mobiletoken";

    NSMutableDictionary *params = [[NSMutableDictionary alloc] init];

    [params setObject:token forKey:@"token"];
    [params setObject:provider forKey:@"provider"];
    [params setObject:appId forKey:@"appid"];
    [params setObject:clientId forKey:@"clientid"];

    HttpClient *httpClient = [HttpClient new];
    [httpClient post:sohuPlusServerUrl postInfo:params success:mySuccessHandler fail:myErrorHandler];

}


- (void)exchangeToken:(NSString *)token
             provider:(NSString *)provider
                appid:(NSString *)appId
             clientid:(NSString *)clientId
              success:(void (^)(SohuPlusToken *))yourSuccessHandler
          errorString:(void (^)(NSString *))yourErrorHandler; {

    void (^mySuccessHandler)(AFHTTPRequestOperation *, id) = ^(AFHTTPRequestOperation *operation, id result) {
        SohuPlusToken *sohuPlusToken = [SohuPlusToken new];
        NSLog(@"Success: %@", operation.responseString);
        NSString *response = operation.responseString;
        NSError *error;
        NSDictionary *resultJSON = [NSJSONSerialization JSONObjectWithData:[response dataUsingEncoding:NSUTF8StringEncoding] options:kNilOptions error:&error];
        NSDictionary *data = [resultJSON objectForKey:@"data"];
        NSString *code = [resultJSON objectForKey:@"code"];
        NSString *msg = [resultJSON objectForKey:@"msg"];
        if ([code intValue] == 0) {
            [sohuPlusToken setAccessToken:[data objectForKey:@"accesstoken"]];
            [sohuPlusToken setRefreshToken:[data objectForKey:@"refreshtoken"]];
            [sohuPlusToken setExpire:[data objectForKey:@"expire"]];
            yourSuccessHandler(sohuPlusToken);
        } else {
            yourErrorHandler(msg);
        }
    };
    void (^myErrorHandler)(AFHTTPRequestOperation *, NSError *) = ^(AFHTTPRequestOperation *operation, NSError *error) {
        NSLog(@"Failure: %@", error);
        yourErrorHandler([error localizedFailureReason]);
    };

//    NSString *sohuPlusServerUrl = @"http://10.10.68.118:9095/spassport/api/mobiletoken";
    NSString *sohuPlusServerUrl = @"http://plus.sohu.com/spassport/api/mobiletoken";

    NSMutableDictionary *params = [[NSMutableDictionary alloc] init];

    [params setObject:token forKey:@"token"];
    [params setObject:provider forKey:@"provider"];
    [params setObject:appId forKey:@"appid"];
    [params setObject:clientId forKey:@"clientid"];

    HttpClient *httpClient = [HttpClient new];
    [httpClient post:sohuPlusServerUrl postInfo:params success:mySuccessHandler fail:myErrorHandler];

}


- (NSString *)genToken:(NSString *)userId
           accessToken:(NSString *)accessToken
                expire:(NSString *)expireTime; {
    NSDictionary *_json_string_ = [NSDictionary dictionaryWithObjectsAndKeys:userId, @"userid", accessToken, @"accesstoken", expireTime, @"expire", nil];
    NSLog(@"json string is %@", _json_string_);
    NSError *error = nil;
    NSData *registerData = [NSJSONSerialization dataWithJSONObject:_json_string_ options:NSJSONWritingPrettyPrinted error:&error];
    if (error != nil) {
        NSLog(@"gen token error %@", error);
        return nil;
    }
    NSString *result = [[NSString alloc] initWithData:registerData encoding:NSUTF8StringEncoding];
    RSA *rsa = [RSA new];
    result = [result stringByReplacingOccurrencesOfString:@"\t" withString:@""];
    result = [result stringByReplacingOccurrencesOfString:@"\n" withString:@""];
    result = [result stringByReplacingOccurrencesOfString:@" " withString:@""];

    NSString *__token = [rsa encryptRSA:result];
    return __token;

}

- (NSString *)genTokenFromWeibo:(WBBaseResponse *)response; {
    NSString *uId = [(WBAuthorizeResponse *) response userID];
    NSString *at = [(WBAuthorizeResponse *) response accessToken];
    NSDate *exp = [(WBAuthorizeResponse *) response expirationDate];
    NSString *timeSp = [NSString stringWithFormat:@"%d", (long) [exp timeIntervalSince1970]];

    return [self genToken:uId accessToken:at expire:timeSp];

}

- (NSString *)genTokenFromTencent:(TencentOAuth *)tencentOAuth; {
    NSString *accessToken = [tencentOAuth accessToken];
    NSString *openId = [tencentOAuth openId];
    NSDate *exp = [tencentOAuth expirationDate];
    NSString *timeSp = [NSString stringWithFormat:@"%d", (long) [exp timeIntervalSince1970]];

    return [self genToken:openId accessToken:accessToken expire:timeSp];
}


- (void)getProfile:(NSString *)clientId
      clientSecret:(NSString *)clientSecret
             scope:(NSString *)scope
        instanceId:(NSString *)instanceId
          username:(NSString *)username
       accessToken:(NSString *)accessToken
           success:(void (^)(SohuPlusProfile *))yourSuccessHandler
             error:(void (^)(NSString *))yourErrorHandler; {
    void (^mySuccessHandler)(AFHTTPRequestOperation *, id) = ^(AFHTTPRequestOperation *operation, id result) {
        NSString *response = operation.responseString;
        NSError *error;
        NSDictionary *resultJSON = [NSJSONSerialization JSONObjectWithData:[response dataUsingEncoding:NSUTF8StringEncoding] options:kNilOptions error:&error];
//        NSDictionary *data = [resultJSON objectForKey:@"data"];
        NSString *sohuplusResult = [resultJSON objectForKey:@"result"];
        if ([sohuplusResult isEqualToString:@"confirm"]) {
            SohuPlusProfile *sohuPlusProfile = [SohuPlusProfile new];
            // handle success
            //resources 里面是code msg的json结构
            NSDictionary *resource = [resultJSON objectForKey:@"resource"];
            NSDictionary *profile = [resource objectForKey:@"data"];
            sohuPlusProfile.sid = [profile objectForKey:@"sid"];
            sohuPlusProfile.sname = [profile objectForKey:@"sname"];
            sohuPlusProfile.email = [profile objectForKey:@"email"];
            sohuPlusProfile.nick = [profile objectForKey:@"nick"];
            sohuPlusProfile.large_avatar = [profile objectForKey:@"large_avatar"];
            sohuPlusProfile.mid_avatar = [profile objectForKey:@"mid_avatar"];
            sohuPlusProfile.tiny_avatar = [profile objectForKey:@"tiny_avatar"];

            NSLog(@"get profile successed! return string is %@", response);
            yourSuccessHandler(sohuPlusProfile);
        } else {
            // handle error
            NSLog(@"get profilr error ! return string is %@", response);
            yourErrorHandler(response);
        }

    };
    void (^myErrorHandler)(AFHTTPRequestOperation *, NSError *) = ^(AFHTTPRequestOperation *operation, NSError *error) {
        NSLog(@"Failure: %@", error);
    };

    // 从 sohuplus 中获获取资源
    NSString *sohuPlusServerUrl = @"http://open.account.sohu.com/oauth2/resource/";

    NSMutableDictionary *params = [[NSMutableDictionary alloc] init];

    [params setObject:clientId forKey:@"client_id"];
    [params setObject:clientSecret forKey:@"client_secret"];
    [params setObject:scope forKey:@"scope"];
    [params setObject:instanceId forKey:@"instance_id"];
    [params setObject:@"full.get" forKey:@"resource_type"];
    [params setObject:username forKey:@"username"];
    [params setObject:accessToken forKey:@"access_token"];

    HttpClient *httpClient = [HttpClient new];
    [httpClient post:sohuPlusServerUrl postInfo:params success:mySuccessHandler fail:myErrorHandler];

}

@end