//
//  Tencent.m
//  saccounts_ios_sdk_sso_framework
//
//  Created by BabyDuncan on 13-9-24.
//  Copyright (c) 2013年 SOHU.COM. All rights reserved.
//

#import "Tencent.h"
#import "TencentOAuth.h"

// 腾讯认证 的全局变量
static TencentOAuth *tencentOAuth;

@implementation Tencent


// 获得腾讯认证的全局变量
// tencentOAuth 的三个属性用于与server交互,分别为:
// [tencentOAuth accessToken]   [tencentOAuth openId]   [tencentOAuth expirationDate]
+ (TencentOAuth *)tencentOAuth; {
    return tencentOAuth;
}

// 把当前app 注册到腾讯sdk
// 参数说明:qqAppkey 为在connect.qq.com 处申请的appid
//         delegate为实现了TencentSessionDelegate 协议的类,如果是AppDelegate 实现了这个协议,可以传递self
//         redirectURI 传递在connect.qq.com 处注册的回调地址 ,此处需要在网站上验证.
- (void)registApp:(NSString *)qqAppkey
         delegate:(id <TencentSessionDelegate>)delegate
      redirectURI:(NSString *)redirectURI; {

    tencentOAuth = [[TencentOAuth alloc] initWithAppId:qqAppkey andDelegate:delegate];
    tencentOAuth.redirectURI = redirectURI;

}

// 调用qq 进行sso登录,如果没有安装qq,则使用内部浏览器进行登录.
// 参数说明: permission
// 权限列表: 在connect.qq.com 上查看,权限有:get_simple_userinfo,get_info 等等
- (void)callQQsso:(NSArray *)permissions; {
    [tencentOAuth authorize:permissions inSafari:NO];
}


@end
