//
// Created by BabyDuncan on 13-9-9.
// Copyright (c) 2013 SOHU.COM. All rights reserved.
//
// To change the template use AppCode | Preferences | File Templates.
//


#import <GHUnitIOS/GHAsyncTestCase.h>
#import "HttpClient.h"

@interface HttpClientTest : GHAsyncTestCase {

}
@end

@implementation HttpClientTest

- (void)testHttpClientGetMethod {

    [self prepare];
    void (^mySuccessHandler)(AFHTTPRequestOperation *, id) = ^(AFHTTPRequestOperation *operation, id result) {
        NSLog(@"Success: %@", operation.responseString);
        [self notify:kGHUnitWaitStatusSuccess];
    };
    void (^myErrorHandler)(AFHTTPRequestOperation *, NSError *) = ^(AFHTTPRequestOperation *operation, NSError *error) {
        NSLog(@"Failure: %@", error);
    };
    HttpClient *httpClient = [HttpClient new];
    NSString *s = @"http://localhost:8080/test/get";
    [httpClient get:s success:mySuccessHandler fail:myErrorHandler];
    [self waitForStatus:kGHUnitWaitStatusSuccess timeout:10.0];

}

- (void)testHttpClientPostMethod {
    [self prepare];
    void (^mySuccessHandler)(AFHTTPRequestOperation *, id) = ^(AFHTTPRequestOperation *operation, id result) {
        NSLog(@"Success: %@", operation.responseString);
        [self notify:kGHUnitWaitStatusSuccess];
    };
    void (^myErrorHandler)(AFHTTPRequestOperation *, NSError *) = ^(AFHTTPRequestOperation *operation, NSError *error) {
        NSLog(@"Failure: %@", error);
    };
    NSString *s = @"http://localhost:8080/test/post";
    NSMutableDictionary *params = [[NSMutableDictionary alloc] init];

    [params setObject:@"1" forKey:@"a"];
    [params setObject:@"2" forKey:@"b"];

    [params setObject:@"3" forKey:@"c"];
    [params setObject:@"4" forKey:@"d"];

    HttpClient *httpClient = [HttpClient new];
    [httpClient post:s postInfo:params success:mySuccessHandler fail:myErrorHandler];
    [self waitForStatus:kGHUnitWaitStatusSuccess timeout:10.0];

}


@end